package servesr

import (
	"context"
	"git.icechen.cn/monorepo/backend/app/brahma/service/token/internal/model"
	"git.icechen.cn/monorepo/backend/app/brahma/service/token/internal/pkg"
	"git.icechen.cn/monorepo/backend/pkg/orm"
	"git.icechen.cn/monorepo/backend/pkg/proto/brahma/murders"
	"git.icechen.cn/monorepo/backend/pkg/proto/brahma/murders/tag"
	"google.golang.org/grpc/codes"
	"google.golang.org/grpc/status"
)

type Tag struct {
	murders.UnimplementedMurdersServer
	pkg.WorkerInterFace
	queryMap *murders.QueryCondition
	tagModel *[]model.Tag
}

func (Tag) GetTags(ctx context.Context, q *murders.QueryCondition) (*tag.Tag, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetTags not implemented")
}

func (w *Tag) Work(ctx context.Context, finishChan chan<- pkg.Finish) {
	go pkg.Watcher(ctx, finishChan)
	db, err := orm.GetContextDB(ctx)
	if err != nil {
		pkg.SafeSend(finishChan, pkg.Finish{
			IsDone: false,
			Err:    err,
		})
	}

	t := new([]model.Tag)
	if err = db.Where("type = ?", "script").Find(t).Error; err != nil {
		pkg.SafeSend(finishChan, pkg.Finish{
			IsDone: false,
			Err:    err,
		})
	}

	w.tagModel = t
	pkg.SafeSend(finishChan, pkg.Finish{
		IsDone: true,
		Err:    nil,
	})

}
